package phonebook;

import java.util.Collections;
import java.util.Comparator;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
import java.util.TreeMap;

/**
 *
 * @author bar
 */
class PersonComparator implements Comparator<Person>{

    public int compare(Person o1, Person o2) {
        String name1 = o1.getSurname()+o1.getName();
        String name2 = o2.getSurname()+o2.getName();
        
        return name1.compareToIgnoreCase(name2);
    }
}

public class PhoneBookImpl implements PhoneBook{

    private Map<Person, Set<Phone>> book = 
                                    new TreeMap<Person,Set<Phone>>(new PersonComparator());
    
    public void addContact(Person person, Phone ... contacts) {
        if( person == null ) throw new IllegalArgumentException("person");
        
        if(contacts == null){
            throw new IllegalArgumentException("contacts");
        }
        
        for(Phone contact:contacts){
            if( contact == null ) throw new IllegalArgumentException("contacts");
        }
        
        Set<Phone> phoneList;
        
        if( book.containsKey(person) ){
            phoneList = book.get(person);
        }else{
            phoneList = new HashSet<Phone>();
        }
        
        for(int i=0;i<contacts.length;i++){
            phoneList.add(contacts[i]);
        }
        book.put(person, phoneList);
        
    }

    public Set<Phone> contacts(Person person) {
        return Collections.unmodifiableSet(book.get(person));
    }

    public Set<Person> persons() {
        return Collections.unmodifiableSet(book.keySet());
    }

}
